clear all;

% Add caffe/matlab to you Matlab search PATH to use matcaffe
addpath('/home/vtu/caffem/matlab/caffe');

% Change here parameters for visualization

%-- we will be using CPU mode, when change to 1 for GPU mode
%-- the routine is failed on the second layer <sig1en>
%-- some mistake in GPU implementation of sigmoid layer
use_gpu = 0; 

%-- the code about caffe works like 10 min, so,
%--if we already run it - we have saved the file on the disk and just load it

if exist('BlobsData.mat', 'file') ~= 2

%-- work with Caffe

model_file = 'mnistCAE14sym0210pu02nm-01_iter_50000.caffemodel';

model_def_file01 = '01-conv1-mnistCAE14sym0210pu02nm.prototxt';
model_def_file02 = '02-sig1en-mnistCAE14sym0210pu02nm.prototxt';
model_def_file03 = '03-pool1-mnistCAE14sym0210pu02nm.prototxt';
model_def_file04 = '04-conv2-mnistCAE14sym0210pu02nm.prototxt';
model_def_file05 = '05-sig2en-mnistCAE14sym0210pu02nm.prototxt';
model_def_file06 = '06-pool2-mnistCAE14sym0210pu02nm.prototxt';
model_def_file07 = '07-ip1encode-mnistCAE14sym0210pu02nm.prototxt';
model_def_file08 = '08-sig3en-mnistCAE14sym0210pu02nm.prototxt';
model_def_file09 = '09-ip2encode-mnistCAE14sym0210pu02nm.prototxt';
model_def_file10 = '10-ip1decode-mnistCAE14sym0210pu02nm.prototxt';
model_def_file11 = '11-sig3de-mnistCAE14sym0210pu02nm.prototxt';
model_def_file12 = '12-deconv2-mnistCAE14sym0210pu02nm.prototxt';
model_def_file13 = '13-sig2de-mnistCAE14sym0210pu02nm.prototxt';
model_def_file14 = '14-unpool2-mnistCAE14sym0210pu02nm.prototxt';
model_def_file15 = '15-deconv1-mnistCAE14sym0210pu02nm.prototxt';
model_def_file16 = '16-sig1de-mnistCAE14sym0210pu02nm.prototxt';
model_def_file17 = '17-unpool1-mnistCAE14sym0210pu02nm.prototxt';
model_def_file18 = '18-deconv1neur-mnistCAE14sym0210pu02nm.prototxt';
model_def_file19 = '19-deconv1neursig-mnistCAE14sym0210pu02nm.prototxt';

TestFileMAT = '/home/vtu/caffe/data/mnistmat/mnist_test.mat';

% Prepare input data
heightW = 28;
widthW = 28;
TE = 10000;

caffein = zeros(heightW, widthW, 1, TE, 'single');
load(TestFileMAT);

for j=1:TE
    for i=1:heightW for k=1:widthW caffein(i, k, 1, j) = test_X(j, k+(i-1)*widthW); end; end
end

% Call Caffe to have outputs for all layers

% 1 layer - conv1 - 24, 24, 26, j
matcaffe_init(use_gpu, model_def_file01, model_file);
conv1 = caffe('forward', {caffein});
conv1 = conv1{1};
caffe('reset');

% 2 layer - sig1en - 24, 24, 26, j
matcaffe_init(use_gpu, model_def_file02, model_file);
sig1en = caffe('forward', {caffein});
sig1en = sig1en{1};
caffe('reset');

% 3 layer - pool1 - 12, 12, 26, j
matcaffe_init(use_gpu, model_def_file03, model_file);
pool1 = caffe('forward', {caffein});
pool1f = pool1{1};	%-- this is a feature map of the layer
caffe('reset');

% 4 layer - conv2 - 8, 8, 36, j
matcaffe_init(use_gpu, model_def_file04, model_file);
conv2 = caffe('forward', {caffein});
conv2 = conv2{1};
caffe('reset');

% 5 layer - sig2en - 8, 8, 36, j
matcaffe_init(use_gpu, model_def_file05, model_file);
sig2en = caffe('forward', {caffein});
sig2en = sig2en{1};
caffe('reset');

% 6 layer - pool2 - 4, 4, 36, j
matcaffe_init(use_gpu, model_def_file06, model_file);
pool2 = caffe('forward', {caffein});
pool2f = pool2{1};	%-- this is a feature map of the layer
caffe('reset');

% 7 layer - ip1encode - 1, 1, 250, j
matcaffe_init(use_gpu, model_def_file07, model_file);
ip1encode = caffe('forward', {caffein});
ip1encode = ip1encode{1};
caffe('reset');

% 8 layer - sig3en - 1, 1, 250, j
matcaffe_init(use_gpu, model_def_file08, model_file);
sig3en = caffe('forward', {caffein});
sig3en = sig3en{1};
caffe('reset');

% 9 layer - ip2encode - 1, 1, 10, j
matcaffe_init(use_gpu, model_def_file09, model_file);
ip2encode = caffe('forward', {caffein});
ip2encode = ip2encode{1};
caffe('reset');

% 10 layer - ip1decode - 1, 1, 250, j
matcaffe_init(use_gpu, model_def_file10, model_file);
ip1decode = caffe('forward', {caffein});
ip1decode = ip1decode{1};
caffe('reset');

% 11 layer - sig3de - 1, 1, 250, j
matcaffe_init(use_gpu, model_def_file11, model_file);
sig3de = caffe('forward', {caffein});
sig3de = sig3de{1};
caffe('reset');

% 12 layer - deconv2 - 4, 4, 36, j
matcaffe_init(use_gpu, model_def_file12, model_file);
deconv2 = caffe('forward', {caffein});
deconv2 = deconv2{1};
caffe('reset');

% 13 layer - sig2de - 4, 4, 36, j
matcaffe_init(use_gpu, model_def_file13, model_file);
sig2de = caffe('forward', {caffein});
sig2de = sig2de{1};
caffe('reset');

% 14 layer - unpool2 - 8, 8, 36, j
matcaffe_init(use_gpu, model_def_file14, model_file);
unpool2 = caffe('forward', {caffein});
unpool2 = unpool2{1};
caffe('reset');

% 15 layer - deconv1 - 12, 12, 26, j
matcaffe_init(use_gpu, model_def_file15, model_file);
deconv1 = caffe('forward', {caffein});
deconv1 = deconv1{1};
caffe('reset');

% 16 layer - sig1de - 12, 12, 26, j
matcaffe_init(use_gpu, model_def_file16, model_file);
sig1de = caffe('forward', {caffein});
sig1de = sig1de{1};
caffe('reset');

% 17 layer - unpool1 - 24, 24, 26, j
matcaffe_init(use_gpu, model_def_file17, model_file);
unpool1 = caffe('forward', {caffein});
unpool1 = unpool1{1};
caffe('reset');

% 18 layer - deconv1neur - 28, 28, 1, j
matcaffe_init(use_gpu, model_def_file18, model_file);
deconv1neur = caffe('forward', {caffein});
deconv1neur = deconv1neur{1};
caffe('reset');

% 19 layer - deconv1neursig - 28, 28, 1, j
matcaffe_init(use_gpu, model_def_file19, model_file);
deconv1neursig = caffe('forward', {caffein});
deconv1neursig = deconv1neursig{1};
caffe('reset');

save BlobsData.mat ...
conv1 sig1en pool1f conv2 sig2en pool2f ip1encode ...
sig3en ip2encode ip1decode sig3de deconv2 sig2de ...
unpool2 deconv1 sig1de unpool1 deconv1neur deconv1neursig;

else
load('BlobsData.mat');
end

% Start visualization 10 different digits from MNIST test file - their indexes below
VisInd = [1, 1820, 3050, 3830, 4510, 5400, 6350, 8000, 8680, 9580];

FontSizeTitle = 10;

for j=6
	% visualize input image
	figure;
	ImVis = caffein(:, :, 1, VisInd(j));
	MinVal = min(min(ImVis));
	MaxVal = max(max(ImVis));
	imagesc(ImVis);
	hT = title(strcat('data-28x28x1-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
        hT.FontSize = FontSizeTitle; 
	set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-00-Original image', '.png'));

	% visualize 1 layer - conv1 - 24, 24, 26, j
	figure;
	for NumIm=1:26
 		ImVis = conv1(:, :, NumIm, VisInd(j));
		subplot(4, 7, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(conv1(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(conv1(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat('conv1|conv1-24x24x26-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
        hT.FontSize = FontSizeTitle; 
	set(gca,'Visible','off'); set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-01-24x24x26 Conv1', '.png'));

	% visualize 2 layer - sig1en - 24, 24, 26, j
	figure;
	for NumIm=1:26
 		ImVis = sig1en(:, :, NumIm, VisInd(j));
		subplot(4, 7, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(sig1en(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(sig1en(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat('conv1|sig1en-24x24x26-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
        hT.FontSize = FontSizeTitle; 
	set(gca,'Visible','off'); set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-02-24x24x26 Sig1en', '.png'));

	% visualize 3 layer - pool1f - 12, 12, 26, j
	figure;
	for NumIm=1:26
 		ImVis = pool1f(:, :, NumIm, VisInd(j));
		subplot(4, 7, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(pool1f(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(pool1f(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat('pool1-12x12x26-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
        hT.FontSize = FontSizeTitle; 
	set(gca,'Visible','off'); set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-03-12x12x26 Pool1f', '.png'));

	% visualize 4 layer - conv2 - 8, 8, 36, j
	figure;
	for NumIm=1:36
 		ImVis = conv2(:, :, NumIm, VisInd(j));
		subplot(6, 6, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(conv2(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(conv2(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat('conv2|conv2-8x8x36-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
        hT.FontSize = FontSizeTitle; 
	set(gca,'Visible','off'); set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-04-8x8x36 Conv2', '.png'));

	% visualize 5 layer - sig2en - 8, 8, 36, j
	figure;
	for NumIm=1:36
 		ImVis = sig2en(:, :, NumIm, VisInd(j));
		subplot(6, 6, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(sig2en(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(sig2en(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat('conv2|sig2en-8x8x36-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
        hT.FontSize = FontSizeTitle; 
	set(gca,'Visible','off'); set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-05-8x8x36 Sig2en', '.png'));

	% visualize 6 layer - pool2f - 4, 4, 36, j
	figure;
	for NumIm=1:36
 		ImVis = pool2f(:, :, NumIm, VisInd(j));
		subplot(6, 6, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(pool2f(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(pool2f(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat('pool2-4x4x36-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
        hT.FontSize = FontSizeTitle; 
	set(gca,'Visible','off'); set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-06-4x4x36 Pool2f', '.png'));

	% visualize 7 layer - ip1encode - 1, 1, 250, j
	figure;
	ImVis = squeeze(ip1encode(1, 1, :, VisInd(j)));
	bar(ImVis); xlim([1 250]);
	hT = title('ip1encode|ip1encode-1x1x250');
        hT.FontSize = FontSizeTitle; 
	set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-07-1x1x250 Ip1encode', '.png'));

	% visualize 8 layer - sig3en - 1, 1, 250, j
	figure;
	ImVis = squeeze(sig3en(1, 1, :, VisInd(j)));
	bar(ImVis); xlim([1 250]);
	hT = title('ip1encode|sig3en-1x1x250');
        hT.FontSize = FontSizeTitle; 
	set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-08-1x1x250 Sig3en', '.png'));

	% visualize 9 layer - ip2encode - 1, 1, 10, j
	figure;
	ImVis = squeeze(ip2encode(1, 1, :, VisInd(j)));
	bar(ImVis); xlim([1 10]);
	hT = title('ip2encode-1x1x10');
        hT.FontSize = FontSizeTitle; 
	set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-09-1x1x10 Ip2encode', '.png'));

	% visualize 10 layer - ip1decode - 1, 1, 250, j
	figure;
	ImVis = squeeze(ip1decode(1, 1, :, VisInd(j)));
	bar(ImVis); xlim([1 250]);
	hT = title('ip1decode|ip1decode-1x1x250');
        hT.FontSize = FontSizeTitle; 
	set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-10-1x1x250 Ip1decode', '.png'));

	% visualize 11 layer - sig3de - 1, 1, 250, j
	figure;
	ImVis = squeeze(sig3de(1, 1, :, VisInd(j)));
	bar(ImVis); xlim([1 250]);
	title(strcat(int2str(test_labels(VisInd(j))), '-11-1x1x250 Sig3de'));
	hT = title('ip1decode|sig3de-1x1x250');
        hT.FontSize = FontSizeTitle; 
	set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-11-1x1x250 Sig3de', '.png'));

	% visualize 12 layer - deconv2 - 4, 4, 36, j
	figure;
	for NumIm=1:36
 		ImVis = deconv2(:, :, NumIm, VisInd(j));
		subplot(6, 6, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(deconv2(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(deconv2(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat('deconv2|deconv2-4x4x36-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
        hT.FontSize = FontSizeTitle; 
	set(gca,'Visible','off'); set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-12-4x4x36 Deconv2', '.png'));

	% visualize 13 layer - sig2de - 4, 4, 36, j
	figure;
	for NumIm=1:36
 		ImVis = sig2de(:, :, NumIm, VisInd(j));
		subplot(6, 6, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(sig2de(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(sig2de(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat('deconv2|sig2de-4x4x36-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
        hT.FontSize = FontSizeTitle; 
	set(gca,'Visible','off'); set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-13-4x4x36 Sig2de', '.png'));

	% visualize 14 layer - unpool2 - 8, 8, 36, j
	figure;
	for NumIm=1:36
 		ImVis = unpool2(:, :, NumIm, VisInd(j));
		subplot(6, 6, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(unpool2(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(unpool2(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat('unpool2-8x8x36-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
        hT.FontSize = FontSizeTitle; 
	set(gca,'Visible','off'); set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-14-8x8x36 Unpool2', '.png'));

	% visualize 15 layer - deconv1 - 12, 12, 26, j
	figure;
	for NumIm=1:26
 		ImVis = deconv1(:, :, NumIm, VisInd(j));
		subplot(4, 7, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(deconv1(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(deconv1(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat('deconv1|deconv1-12x12x26-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
        hT.FontSize = FontSizeTitle; 
	set(gca,'Visible','off'); set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-15-12x12x26 Deconv1', '.png'));

	% visualize 16 layer - sig1de - 12, 12, 26, j
	figure;
	for NumIm=1:26
 		ImVis = sig1de(:, :, NumIm, VisInd(j));
		subplot(4, 7, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(sig1de(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(sig1de(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat('deconv1|sig1de-12x12x26-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
        hT.FontSize = FontSizeTitle; 
	set(gca,'Visible','off'); set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-16-12x12x26 Sig1de', '.png'));

	% visualize 17 layer - unpool1 - 24, 24, 26, j
	figure;
	for NumIm=1:26
 		ImVis = unpool1(:, :, NumIm, VisInd(j));
		subplot(4, 7, NumIm), imagesc(ImVis), axis off;
	end
	MinVal = min(min(min(unpool1(:, :, :, VisInd(j)))));
	MaxVal = max(max(max(unpool1(:, :, :, VisInd(j)))));
	set(gcf,'NextPlot','add'); axes;
	hT = title(strcat('unpool1-24x24x26-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
        hT.FontSize = FontSizeTitle; 
	set(gca,'Visible','off'); set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-17-24x24x26 Unpool1', '.png'));

	% visualize 18 layer - deconv1neur - 28, 28, 1, j
	figure;
	ImVis = deconv1neur(:, :, 1, VisInd(j));
	MinVal = min(min(ImVis));
	MaxVal = max(max(ImVis));
	imagesc(ImVis);
	hT = title(strcat('deconv1neur-28x28x1-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
        hT.FontSize = FontSizeTitle; 
	set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-18-28x28x1 Deconv1neur', '.png'));

	% visualize 19 layer - deconv1neursig - 28, 28, 1, j
	figure;
	ImVis = deconv1neursig(:, :, 1, VisInd(j));
	MinVal = min(min(ImVis));
	MaxVal = max(max(ImVis));
	imagesc(ImVis);
	hT = title(strcat('deconv1neursig-28x28x1-[', num2str(MinVal,4), '..', num2str(MaxVal,4), ']'));
        hT.FontSize = FontSizeTitle; 
	set(hT,'Visible','off'); set(hT,'Visible','on'); 
	saveas(gcf, strcat(int2str(test_labels(VisInd(j))), '-19-28x28x1 Deconv1neursig', '.png'));
end
















