clear all;

% Add caffe/matlab to you Matlab search PATH to use matcaffe
addpath('/home/vtu/caffem/matlab/caffe');

% Change here parameters for visualization
use_gpu = 0; %-- we will be using CPU mode, change to 1 - for GPU mode

model_def_file = 'mnistCAE14sym0202pu02.prototxt';
model_file = 'mnistCAE14sym0202pu02nm-03_iter_50000.caffemodel';
TestFileMAT = '/home/vtu/caffe/data/mnistmat/mnist_test.mat';

% Prepare input data
heightW = 28;
widthW = 28;
TE = 10000;

caffein = zeros(heightW, widthW, 1, TE, 'single');
load(TestFileMAT);

for j=1:TE
    for i=1:heightW for k=1:widthW caffein(i, k, 1, j) = test_X(j, k+(i-1)*widthW); end; end
end

% Work with caffe 
matcaffe_init(use_gpu, model_def_file, model_file);
pc2 = caffe('forward', {caffein});
pc2 = pc2{1};
caffe('reset');
pc2 = (squeeze(pc2)');

figure;
gscatter(pc2(:,1), pc2(:,2), test_labels), grid on;
title(model_file);
xlabel('1st dimension');
ylabel('2nd dimension');
saveas(gcf, strcat(model_file, '.png'));